#include <stdio.h>
#include <string.h>
#include <ctype.h>

#ifdef __STDC__
#include <stdlib.h>
#define ARGS(plist)	plist
#else
#define const
#define ARGS(plist)	()
#endif

#ifndef EXTERN
#define EXTERN extern
#endif

#if __STDC__
#define ERR_PREFIX		"\?\? "	/* not a trigraph! */
#else
#define ERR_PREFIX		"?? "
#endif

#define FFLUSH			(void)fflush
#define FPRINTF			(void)fprintf
#define MAXLEVEL		25	/* maximum conditional nesting */
#define MAXLINE			255	/* maximum input line length */
#define MSG_PREFIX		"!! "
#define NOOP
#define OUT_PREFIX		"C-fpp-"
#define PERMANENT(s)		((s[0] == '_') && (s[1] == '_'))
#define PRINTF			(void)printf
#define SPRINTF			(void)sprintf
#define STDIN			"--"
#define VERSION			"fpp -- C version 1.0.7 [04-Nov-1991]"

#define initial(c)		(fpp_line[0] == (c))
#define is_comment()	( initial('C') || initial('c') || initial('*') )
#define is_id_line()	(is_comment() && (strncmp(&fpp_line[1],"-fpp-",5) == 0))
#define is_token_start(c)	(isalpha(c) || ((c) == '_'))
#define is_token_letter(c)	(isalnum(c) || ((c) == '_'))
#define print_line(p)		(void)puts(p)
#define skip_whitespace(p)	while(isspace(*p)) ++p
#define stddbg			stderr

#ifndef EXIT_FAILURE
#define EXIT_FAILURE 1
#endif

#ifndef EXIT_SUCCESS
#define EXIT_SUCCESS 0
#endif

EXTERN int branch_done[MAXLEVEL];	/* for conditional branch records */
EXTERN char err_line[MAXLINE+1];	/* error message buffer */
EXTERN char expression[2*MAXLINE+1];	/* for expression expansion */
EXTERN char *ee[MAXLINE+1];		/* pointers into expression[] */
EXTERN int FNR;				/* record number in current file */
EXTERN int fpp_code;			/* exit code */
EXTERN int fpp_debug;			/* non-zero if debugging */
EXTERN FILE *fpp_infile;		/* pointer to current input file */
EXTERN char fpp_line[MAXLINE+1];	/* current input line */
EXTERN char *fpp_name;			/* current input file name */
EXTERN char fpp_number[18];		/* current input line number */
EXTERN int level;			/* conditional nesting level */
EXTERN int ke;				/* current expression fields */
EXTERN int lineno[MAXLEVEL];		/* for conditional branch records */
EXTERN int ne;				/* number of expression fields */
EXTERN int NR;				/* record number in input */
EXTERN int RSTART;			/* regexp match begin in fpp_line */
EXTERN int RLENGTH;			/* regexp match length in fpp_line */
EXTERN int selected[MAXLEVEL];		/* for conditional branch flagging */
EXTERN char *TOKEN;			/* pointer to pp-token in fpp_line */

char	*concat ARGS((char *s, char *t));
char	*defined ARGS((void));
int	doarg ARGS((char *s));
void	dodef ARGS((char *s));
void	dodef2 ARGS((char *name, char *value, int permanent));
void	dofile ARGS((char *filename));
void	doundef ARGS((char *s));
char	*dtos ARGS((double d));
void	error ARGS((char *message, int dump_lineno));
char	*eval ARGS((char *s));
char	*expand ARGS((char *s));
char	*expr ARGS((void));
char	*factor ARGS((void));
char	*getdef ARGS((char *s));
int	getline ARGS((void));
char	*getname ARGS((char *s, int start));
int	hash ARGS((char *name));
char	*identification ARGS((void));
void	init ARGS((void));
int	install ARGS((char *name, char *value));
int 	is_macro_line ARGS((void));
int 	is_pp_line ARGS((void));
int	lookup ARGS((char *name));
void	macro_line ARGS((void));
int	main ARGS((int argc, char *argv[]));
int	match_expr ARGS((char *s));
int	name ARGS((char *s));
void	normal_line ARGS((void));
int	number ARGS((char *s));
char	*power ARGS((void));
void	pp_line ARGS((void));
void	process ARGS((void));
void	quit ARGS((char *message, int dump_lineno));

#ifndef __sgi
char	*strdup ARGS((char *s));
#endif

int	stricmp ARGS((char *s, char *t));
int	strnicmp ARGS((char *s, char *t, size_t n));
char	*term ARGS((void));
void	tokenize ARGS((char *s));
char	*trim ARGS((char *s));
