#include "fpp.h"

int
number(s) /* [-+]?([0-9]+[.]?[0-9]*|[0-9]*[.]?[0-9]+)([DEde][+-]?[0-9]+)? */
char *s;
{
    int		ndigits;
    int		RLENGTH_save;

    RLENGTH = 0;

    for (RSTART = 0; *s && isspace(*s); ++s, ++RSTART)
	NOOP;				/* advance over leading whitespace */

    if ( (*s == '+') || (*s == '-') )
    {
	if (isdigit(s[1]) || ( (s[1] == '.') && isdigit(s[2]) ) )
	    ++s, ++RLENGTH;
	else
	    return RSTART;
    }

    for (ndigits = 0; isdigit(*s); ++RLENGTH, ++s, ++ndigits)
	NOOP;

    if (*s == '.')
    {
	if ( (ndigits > 0) || isdigit(s[1]) )
	{
	    if (isalpha(s[1]) && (isalpha(s[2]) || (s[2] == '.')))
	        return RSTART;		/* looks like 1.eq.3 or 1.x.3 */
					/* so return pure integer string */
	    else
	        ++s, ++RLENGTH;		/* accept dot as part of number */
	}
	else			/* ndigits == 0, and no following digit */
	{
	    RLENGTH = 0;
	    return RSTART;
	}
    }

    for (; isdigit(*s); ++RLENGTH, ++s, ++ndigits)
	NOOP;

    if (ndigits == 0)			/* cannot be a number */
    {
	RLENGTH = 0;
	return RSTART;
    }
    else if ( (*s == 'E') || (*s == 'e') || (*s == 'D') || (*s == 'd') )
    {
	RLENGTH_save = RLENGTH;	/* might have to backtrack to this point */
	++s, ++RLENGTH;
    }
    else
	return RSTART;			/* no exponent field */

    if ( (*s == '+') || (*s == '-') )
	++s, ++RLENGTH;

    for (ndigits = 0; isdigit(*s); ++RLENGTH, ++s, ++ndigits)
	NOOP;

    if (ndigits == 0)			/* cannot be an exponent */
    {
	RLENGTH = RLENGTH_save;		/* backtrack to valid number end */
	return RSTART;
    }
    else
	return RSTART;		/* successful parse of exponent field */
}
