#include "fpp.h"

#define OP(s,n) (strnicmp(p,s,n) == 0)

void
tokenize(s)
char *s;
{
    char *p;
    char *q;
    int k;

    for (ne = 0, p = s, q = expression; *p; )
    {					/* tokenize the expression */
	skip_whitespace(p);
	ee[ne] = q;
	if (*p == '+')
	    *q++ = *p++, *q++ = '\0', ne++;
	else if (*p == '-')
	    *q++ = *p++, *q++ = '\0', ne++;
	else if (*p == '%')
	    *q++ = *p++, *q++ = '\0', ne++;
	else if (*p == '*')		/* have * or ** */
	{
	    *q++ = *p++;
	    skip_whitespace(p);
	    if (*p == '*')
		*q++ = *p++;
	    *q++ = '\0', ne++;
	}
	else if (*p == '/')		/* have / or // */
	{
	    *q++ = *p++;
	    skip_whitespace(p);
	    if (*p == '/')
		*q++ = *p++;
	    *q++ = '\0', ne++;
	}
	else if (*p == '=')		/* have == */
	{
	    *q++ = *p++;
	    skip_whitespace(p);
	    if (*p == '=')	/* if we have only =, we catch it later */
		*q++ = *p++;
	    *q++ = '\0', ne++;
	}
	else if (*p == '<')		/* have < or << or <= */
	{
	    *q++ = *p++;
	    skip_whitespace(p);
	    if ((*p == '<') || (*p == '='))
		*q++ = *p++;
	    *q++ = '\0', ne++;
	}
	else if (*p == '>')		/* have > or >> or >= */
	{
	    *q++ = *p++;
	    skip_whitespace(p);
	    if ((*p == '>') || (*p == '='))
		*q++ = *p++;
	    *q++ = '\0', ne++;
	}
	else if (*p == '!')		/* have ! or != */
	{
	    *q++ = *p++;
	    skip_whitespace(p);
	    if (*p == '=')
		*q++ = *p++;
	    *q++ = '\0', ne++;
	}
	else if (*p == '&')		/* have & or && */
	{
	    *q++ = *p++;
	    skip_whitespace(p);
	    if (*p == '&')
		*q = *p++;		/* reduce && to & */
	    *q++ = '\0', ne++;
	}
	else if (*p == '|')		/* have | or || */
	{
	    *q++ = *p++;
	    skip_whitespace(p);
	    if (*p == '|')
		*q = *p++;		/* reduce || to | */
	    *q++ = '\0', ne++;
	}
	else if (*p == '(')
	    *q++ = *p++, *q++ = '\0', ne++;
	else if (*p == ')')
	    *q++ = *p++, *q++ = '\0', ne++;
	else if (*p == '.')
	{
	    if (OP(".not.",5))
		*q++ = '!', *q++ = '\0', ne++, p += 5;
	    else if (OP(".and.",5))
		*q++ = '&', *q++ = '\0', ne++, p += 5;
	    else if (OP(".or.",4))
		*q++ = '|', *q++ = '\0', ne++, p += 4;
	    else if (OP(".eq.",4))
		*q++ = '=', *q++ = '=', *q++ = '\0', ne++, p += 4;
	    else if (OP(".ne.",4))
		*q++ = '!', *q++ = '=', *q++ = '\0', ne++, p += 4;
	    else if (OP(".lt.",4))
		*q++ = '<', *q++ = '\0', ne++, p += 4;
	    else if (OP(".gt.",4))
		*q++ = '>', *q++ = '\0', ne++, p += 4;
	    else if (OP(".le.",4))
		*q++ = '<', *q++ = '=', *q++ = '\0', ne++, p += 4;
	    else if (OP(".ge.",4))
		*q++ = '>', *q++ = '=', *q++ = '\0', ne++, p += 4;
	    else if (OP(".eqv.",5))
		*q++ = '.', *q++ = 'e', *q++ = 'q', *q++ = 'v',
		*q++ = '.', *q++ = '\0', ne++, p += 5;
	    else if (OP(".neqv.",6))
		*q++ = '.', *q++ = 'n', *q++ = 'e', *q++ = 'q', *q++ = 'v',
		*q++ = '.', *q++ = '\0', ne++, p += 6;
	    else if (isdigit(p[1]))	/*  */
	    {
		(void)number(p);
		(void)strncpy(q,p,RLENGTH);
		p += RLENGTH;
		q += RLENGTH;
		*q++ = '\0';
		ne++;
	    }
	    else
		quit("Unrecognized token in expression",0);
	}
	else if (isdigit(*p))
	{
	    (void)number(p);
	    (void)strncpy(q,p,RLENGTH);
	    p += RLENGTH;
	    q += RLENGTH;
	    *q++ = '\0';
	    ne++;
	}
	else if (is_token_start(*p))
	{
	    name(p);
	    (void)strncpy(q,p,RLENGTH);
	    p += RLENGTH;
	    q += RLENGTH;
	    *q++ = '\0';
	    ne++;
	}
	else
	    quit("Unrecognized token in expression",0);
    }
    if (fpp_debug)
    {
	FPRINTF(stddbg,"DEBUG: tokenize [%s] ->",s);
	for (k = 0; k < ne; ++k)
	    FPRINTF(stddbg," [%s]",ee[k]);
	FPRINTF(stddbg,"\n");
	FFLUSH(stddbg);
    }
    ke = 0;				/* point to first field */
}
