C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       LABELS,      SYSDCD
C
      CALL SYSDCD (5,4H.LAB,6,4H.LST)
      CALL LABELS (5,6,-4)
      STOP
      END
      SUBROUTINE  LABELS (NIN,NOUT,NERR)
C     (Address Labels)
C
C                      L A B E L   U T I L I T Y
C
C     Print multiple  copies of  address  labels from  an  address
C     file.  Entries have the form
C
C     = Optional title
C     * Optional remark
C     Name...
C     Address Line 1...
C     Address Line 2...
C     Address Line 3...
C     Address Line 4...
C     Address Line 5...
C     Address Line 6...
C     Address Line 7...
C      Phone Line 1...
C      Phone Line 2...
C      Date: YYMMDD
C
C     Each line may  contain up  to 50  characters in  upper/lower
C     case.  The number of  lines for the  name and address  lines
C     may be at  most 8.  At  least one blank  line must  separate
C     successive address entries.  The date line "Date: YYMMDD" is
C     optional, and if omitted, is equivalent to "Date: 0"
C
C     An asterisk in column 1 prefixes remarks which are not to be
C     output; a remark may be placed anywhere in the address file,
C     even within addresses.
C
C     A title for  the output listing  may be supplied  on a  line
C     prefixed by an equals sign.
C
C     Lines distinguished by a  blank in column  1, with at  least
C     one non-blank in the remaining columns, may be used for  any
C     purpose, such as phone numbers, invoice data, etc., and will
C     not be printed in the output listing.
C
C     Five  runtime  options   are  available  from   command-line
C     switches:
C
C     /A:YYMMDD Select only addresses with date entries
C               after  YYMMDD.
C     /B:YYMMDD Select only addresses with date entries
C               before YYMMDD.
C     /C:nn     Make nn copies of each address entry as it is
C               encountered.
C     /I:nn     Indent output listing by nn columns.
C     /R:nn     Reprint the input file nn times.
C
C     Default switches are: /A:-1  /B:maxint  /C:1  /I:0  /R:1
C
C     For example:
C
C     @LABELS /A:790324 /C:10 /I:5 /R:3  infile outfile
C
C     This would select  address entries with  dates on or  after
C     790325, print 10 successive copies of each label indented 5
C     columns, and print the address file 3 times.
C
C     The default file extensions for infile and outfile are .LAB
C     and .LST respectively.
C     (03-JUL-85)
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       I1MACH,      KARCM2,      KARIDX,      KARPAK
C     EXTERNAL REFS       MOD,         SYSCMD,      UTIDI
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL FUNCTIONS AND SUBROUTINES
C
      INTEGER             I1MACH,      KARCM2,      KARIDX
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     INTRINSIC FUNCTIONS
C
      INTEGER             MOD
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     STATEMENT FUNCTIONS
C
      LOGICAL             IN
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
C     SETS                ADRESS,      AFTER,       BEFORE,      COPIES
C     SETS                DATE,        DD,          EMPTY,       EOFILE
C     SETS                HEAD,        HEADER,      I,           INDENT
C     SETS                KTIME,       L,           LC,          LENGTH
C     SETS                LIMIT,       LINE,        MM,          N
C     SETS                NUMADD,      PHONE,       PRINT,       REMARK
C     SETS                REPEAT,      TITLE,       YY
C
      DOUBLE PRECISION    SWITCH(5)
      INTEGER             ADRESS(50,8),AFTER,       BEFORE,      BLANK
      INTEGER             COPIES,      DATE,        DD,          EQUALS
      INTEGER             HEADER(79),  I,           IARG1
      INTEGER             IARG2,       IARG3,       INDENT
      INTEGER             KTIME,       L,           LABSIZ,      LC
      INTEGER             LCMAX,       LENGTH(8),   LIMIT
      INTEGER             LINE(80),    LNSIZE,      MAXHDR
      INTEGER             MAXSW,       MM,          N
      INTEGER             NERR,        NIN
      INTEGER             NOUT,        NUMADD,      NUMFIL,      NUMSW
      INTEGER             PLINE(80),   REPEAT,      STAR
      INTEGER             VALUE(3),    YY
      LOGICAL             EMPTY,       EOFILE,      ERROR,       HEAD
      LOGICAL             PHONE,       PRINT,       REMARK,      TITLE
C
C     LCMAX.....Number of printable lines on a label.
C     LABSIZ....Number of lines between successive top-of-label lines.
C     LNSIZE....Length of longest address line and dimension of LINE(*).
C
      DATA                BLANK     / 1H  /
      DATA                EQUALS    / 1H= /
      DATA                LABSIZ    / 9 /
      DATA                LCMAX     / 8 /
      DATA                LNSIZE    / 50 /
      DATA                MAXHDR    / 79 /
      DATA                MAXSW     / 5 /
      DATA                STAR      / 1H* /
C
      IN(IARG1,IARG2,IARG3) = (IARG1 .LE. IARG2) .AND. (IARG2 .LE.
     XIARG3)
C
      ASSIGN 20001 TO NPR001
      GO TO 30001
20001 KTIME =1
      N20002=REPEAT
      GO TO 20003
20002 KTIME =KTIME +1
20003 IF ((N20002-KTIME ).LT.0) GO TO 20004
      ASSIGN 20006 TO NPR002
      GO TO 30002
20006 CONTINUE
20007 IF (.NOT.(.NOT.EOFILE)) GO TO 20008
      ASSIGN 20009 TO NPR003
      GO TO 30003
20009 IF (.NOT.(PRINT)) GO TO 20010
      ASSIGN 20013 TO NPR004
      GO TO 30004
20013 GO TO 20011
20010 IF (.NOT.(PHONE)) GO TO 10001
      ASSIGN 20014 TO NPR005
      GO TO 30005
20014 GO TO 20011
10001 IF (.NOT.(EMPTY)) GO TO 10002
      ASSIGN 20015 TO NPR006
      GO TO 30006
20015 ASSIGN 20016 TO NPR007
      GO TO 30007
20016 GO TO 20011
10002 IF (.NOT.(TITLE)) GO TO 10003
      ASSIGN 20017 TO NPR008
      GO TO 30008
20017 GO TO 20011
10003 IF (.NOT.(REMARK)) GO TO 10004
10004 CONTINUE
20011 CONTINUE
20012 ASSIGN 20018 TO NPR002
      GO TO 30002
20018 GO TO 20007
20008 ASSIGN 20019 TO NPR006
      GO TO 30006
20019 ASSIGN 20020 TO NPR007
      GO TO 30007
20020 REWIND NIN
      GO TO 20002
20004 RETURN
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Check for Date)
30005 CALL KARPAK (PLINE,1,LINE,80)
      L = KARIDX(PLINE,1,80,5HDate:,1,5)
      IF (.NOT.(L .GT. 0)) GO TO 20021
      CALL UTIDI (DATE,L+5,ERROR,LINE,80,10,.TRUE.)
      IF (DATE .EQ. 0) GO TO 20022
      YY = DATE/10000
      MM = MOD(DATE/100,100)
      DD = MOD(DATE,100)
      IF (.NOT.(.NOT.(IN(70,YY,99) .AND. IN(01,MM,12) .AND.
     XIN(01,MM,31)))) GO TO 20024
      WRITE (NERR,2000)
      N =1
      N20027=LC
      GO TO 20028
20027 N =N +1
20028 IF ((N20027-N ).LT.0) GO TO 20029
      LIMIT = LENGTH(N)
      WRITE (NERR,3000) (ADRESS(L,N), L = 1,LIMIT)
      GO TO 20027
20029 STOP
20024 CONTINUE
20021 CONTINUE
20022 GO TO 20014
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Classify Line)
30003 TITLE = (LINE(1) .EQ. EQUALS)
      REMARK = (LINE(1) .EQ. STAR)
      PRINT = (LINE(1) .NE. BLANK) .AND. .NOT.(REMARK .OR. TITLE)
      EMPTY = .NOT.(PRINT .OR. REMARK)
      L = 2
20031 IF (.NOT.(EMPTY .AND. (L .LE. LNSIZE))) GO TO 20032
      EMPTY = (LINE(L) .EQ. BLANK)
      L = L + 1
      GO TO 20031
20032 PHONE = .NOT. (TITLE .OR. PRINT .OR. REMARK .OR. EMPTY)
      GO TO 20009
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Initialize)
30001 HEAD = .FALSE.
      LC = 0
      NUMADD = 0
      DATE = 0
      AFTER = -I1MACH(9)
      BEFORE = I1MACH(9)
      COPIES = 0
      INDENT = 0
      REPEAT = 1
      CALL SYSCMD (0,0,NUMFIL,SWITCH,VALUE,MAXSW,NUMSW)
      L =1
      N20033=NUMSW
      GO TO 20034
20033 L =L +1
20034 IF ((N20033-L ).LT.0) GO TO 20035
      IF (.NOT.(KARCM2(SWITCH(L),1,1HA,1,1) .EQ. 0)) GO TO 20037
      AFTER = VALUE(L)
      GO TO 20038
20037 IF (.NOT.(KARCM2(SWITCH(L),1,1HB,1,1) .EQ. 0)) GO TO 10005
      BEFORE = VALUE(L)
      GO TO 20038
10005 IF (.NOT.(KARCM2(SWITCH(L),1,1HC,1,1) .EQ. 0)) GO TO 10006
      COPIES = VALUE(L)
      GO TO 20038
10006 IF (.NOT.(KARCM2(SWITCH(L),1,1HI,1,1) .EQ. 0)) GO TO 10007
      INDENT = VALUE(L)
      GO TO 20038
10007 IF (.NOT.(KARCM2(SWITCH(L),1,1HR,1,1) .EQ. 0)) GO TO 10008
      REPEAT = VALUE(L)
10008 CONTINUE
20038 GO TO 20033
20035 IF (AFTER  .LT. 1) AFTER = -I1MACH(9)
      IF (BEFORE .LE. AFTER) BEFORE = I1MACH(9)
      IF (COPIES .LT. 1) COPIES = 1
      IF (INDENT .LT. 1) INDENT = 1
      IF (REPEAT .LT. 1) REPEAT = 1
      GO TO 20001
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Input a Line)
30002 READ (NIN,1000,END=20040) LINE
      EOFILE=.FALSE.
      GO TO 20041
20040 EOFILE=.TRUE.
20041 GO TO NPR002, (20006,20018)
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Print Multiple Copies of the Current Label)
30007 IF (.NOT.((LC .GT. 0) .AND. (DATE .GT. AFTER) .AND.
     X(DATE .LT. BEFORE))) GO TO 20042
      I =1
      N20045=COPIES
      GO TO 20046
20045 I =I +1
20046 IF ((N20045-I ).LT.0) GO TO 20047
      N =1
      N20049=LCMAX
      GO TO 20050
20049 N =N +1
20050 IF ((N20049-N ).LT.0) GO TO 20051
      LIMIT = LENGTH(N)
      WRITE (NOUT,1000) (BLANK,L=1,INDENT),
     X(ADRESS(L,N),L=1,LIMIT)
      GO TO 20049
20051 N =LCMAX+1
      N20053=LABSIZ
      GO TO 20054
20053 N =N +1
20054 IF ((N20053-N ).LT.0) GO TO 20055
      WRITE (NOUT,1000)
      GO TO 20053
20055 GO TO 20045
20047 CONTINUE
20042 LC = 0
      DATE = 0
      GO TO NPR007, (20016,20020)
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Store a Line)
30004 LC = LC + 1
      IF (.NOT.(LC .LE. LCMAX)) GO TO 20057
      ASSIGN 20060 TO NPR009
      GO TO 30009
20060 L =1
      N20061=LENGTH(LC)
      GO TO 20062
20061 L =L +1
20062 IF ((N20061-L ).LT.0) GO TO 20063
      ADRESS(L,LC) = LINE(L)
      GO TO 20061
20063 CONTINUE
20057 GO TO 20013
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Store Header Line)
30008 I =1
      N20065=MAXHDR
      GO TO 20066
20065 I =I +1
20066 IF ((N20065-I ).LT.0) GO TO 20067
      HEADER(I) = LINE(I+1)
      GO TO 20065
20067 HEAD = .TRUE.
      GO TO 20017
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Store Spacer Lines)
30006 IF (.NOT.(LC .NE. 0)) GO TO 20069
      N =LC+1
      N20072=LCMAX
      GO TO 20073
20072 N =N +1
20073 IF ((N20072-N ).LT.0) GO TO 20074
      ADRESS(1,N) = BLANK
      LENGTH(N) = 1
      GO TO 20072
20074 CONTINUE
20069 GO TO NPR006, (20015,20019)
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Trim Trailing Blanks on Line)
30009 LIMIT = LNSIZE
20076 IF (.NOT.((LINE(LIMIT) .EQ. BLANK) .AND. (LIMIT .GT. 1))) GO TO 20
     X077
      LIMIT = LIMIT - 1
      GO TO 20076
20077 LENGTH(LC) = LIMIT
      GO TO 20060
C
 1000 FORMAT (133A1)
 2000 FORMAT (42H ?Illegal DATE field in following address:)
 3000 FORMAT (1X,133A1)
      END
