.TH LABELS 1L "31 January 1991"
.SH NAME
labels \- Make multiple copies of address labels
from an address file
.SH USAGE
labels
.SH OPTIONS
Five run-time options are available from
command-line switches; switch letter case is
insignificant:
.TP \w'\-a:YYMMDD'u+2n
.BI \-a :YYMMDD
Select only addresses with date entries after
.IR YYMMDD .
.TP
.BI \-b :YYMMDD
Select only addresses with date entries before
.IR YYMMDD .
.TP
.IR \-c :nn
Make
.I nn
copies of each address entry as it
is encountered.
.TP
.BI -i :nn
Indent output listing by
.I nn
columns.
.TP
.BI \-r :nn
Reprint the input file
.I nn
times.
.PP
Default switches are:
.PP
\-a:-1 \-b:999999 \-c:1 \-i:0 \-r:1
.PP
For example:
.PP
labels \-a:790324 \-c:10 \-i:5 \-r:3  <infile >outfile
.PP
This would select address entries with dates on or
after 790325, print 10 successive copies of each
label indented 5 columns, and print the address
file 3 times.
.SH DESCRIPTION
.B labels
makes multiple copies of address labels from an
address file.  Entries have the form
.nf
= Optional title
* Optional remark
Name...
Address Line 1...
Address Line 2...
Address Line 3...
Address Line 4...
Address Line 5...
Address Line 6...
Address Line 7...
 Phone Line 1...
 Phone Line 2...
 Date: YYMMDD
.fi
.PP
Each line may contain up to 50 characters in
upper/lower case.  The number of lines for the
name and address lines may be at most 8.  At least
one blank line must separate successive address
entries.  The date line
.I "Date: YYMMDD"
is optional, and if omitted, is equivalent to
.IR "Date: 0" .
.PP
An asterisk in column 1 prefixes remarks which are
not to be output; a remark may be placed anywhere
in the address file, even within addresses.
.PP
A title for the output listing may be supplied on
a line prefixed by an equals sign.
.PP
Lines distinguished by a blank in column 1, with
at least one non-blank in the remaining columns,
may be used for any purpose, such as phone
numbers, invoice data, etc., and will not be
printed in the output listing.
.PP
The output is a file with the selected labels.  On
older printers that support label rolls, it may be
possible to print it directly.  On modern laser
printers, the output should be formatted
separately into multiple columns, such as is
possible with the UNIX
.IR pr (1)
utility.  For PostScript printers, the
.IR lptops (1)
utility can be used to do the job, as follows:
.PP
.nf
labels .\|.\|. | \\
   lptops -m3 -p10pt -t0.25in -b0in -l0.25in -r0in -fTimes-Bold | \\
   lpr -Psomeprintername
.fi
.PP
This will format the output of
.B labels
into 3 columns with margins that match those of
Avery brand 5360 labels, which have 3 columns of 7
labels per page, and are suitable for hand feeding
into a laser printer or photocopier.
.PP
This combination of
.B labels
and
.IR lptops (1)
has been encapsulated in a convenient shell
script,
.IR PSlabels (1),
whose manual page can be consulted for further
details.
.SH "AUTHOR"
Nelson H. F. Beebe, Ph.D.
.br
Center for Scientific Computing
.br
Department of Mathematics
.br
220 South Physics Building
.br
University of Utah
.br
Salt Lake City, UT 84112
.br
Tel: (801) 581-5254
.br
FAX: (801) 581-4148
.br
E-mail: <beebe@math.utah.edu>
